"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var metadata_1 = require("./metadata");
var module_builder_1 = require("./module-builder");
var types_1 = require("./types");
var utils_1 = require("./utils");
function handleOptions(options) {
    if (typeof options === 'string') {
        return {
            namespace: options
        };
    }
    return options;
}
function Module(pOptions) {
    return function (target) {
        metadata_1.collectDecorators(target);
        var options = handleOptions(pOptions);
        var moduleWrapper = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var instance = new (target.bind.apply(target, [void 0].concat(args)))();
            var moduleBuilder = new module_builder_1.ModuleBuilder(options.namespace, {});
            metadata_1.applyDecorators(moduleBuilder, instance);
            instance.__moduleBuilder__ = moduleBuilder;
            utils_1.injectUtil.injectAll(instance);
            return instance;
        };
        moduleWrapper.prototype = target.prototype;
        return moduleWrapper;
    };
}
exports.Module = Module;
function State() {
    return function (target, propertyName) {
        utils_1.decoratorUtil.setDecorator(target, propertyName, types_1.DecoratorType.STATE);
    };
}
exports.State = State;
function Inject(typeOrName) {
    return function (target, propertyName, index) {
        utils_1.injectUtil.registerInjection(target, propertyName, typeOrName, index);
    };
}
exports.Inject = Inject;
function Getter() {
    return function (target, propertyName, descriptor) {
        utils_1.decoratorUtil.setDecorator(target, propertyName, types_1.DecoratorType.GETTER);
    };
}
exports.Getter = Getter;
function Mutation() {
    return function (target, propertyName, descriptor) {
        utils_1.decoratorUtil.setDecorator(target, propertyName, types_1.DecoratorType.MUTATION);
    };
}
exports.Mutation = Mutation;
function Action() {
    return function (target, propertyName, descriptor) {
        utils_1.decoratorUtil.setDecorator(target, propertyName, types_1.DecoratorType.ACTION);
    };
}
exports.Action = Action;
//# sourceMappingURL=decorators.js.map