import { Action, Getter, Module, Mutation } from 'vuex';
import { StoreBuilder } from './store-builder';
export declare class ModuleBuilder<State = any, RootState = any> {
    private _storeBuilder?;
    private _module;
    private _namespace;
    constructor(namespace: string, state: State);
    setStoreBuilder(storeBuilder: StoreBuilder<RootState>): void;
    addAction(name: string, action: Action<State, RootState>): void;
    addMutation(name: string, mutation: Mutation<State>): void;
    addGetter(name: string, getter: Getter<State, RootState>): void;
    state(): any;
    commit(name: string, payload: any): void;
    read(name: string): any;
    dispatch(name: string, payload: any): Promise<any>;
    readonly module: Module<State, RootState>;
    readonly namespace: string;
}
