import { ContainerInstance } from 'typedi';
import { Module, Store, StoreOptions } from 'vuex';
interface StoreBuilderOptions<R> extends StoreOptions<R> {
    container?: ContainerInstance;
}
export declare class StoreBuilder<State extends Object> {
    private _container;
    private _options;
    private _store?;
    readonly container: ContainerInstance;
    readonly store: Store<State> | undefined;
    constructor(options?: StoreBuilderOptions<State>);
    initialize(options: StoreBuilderOptions<State>): void;
    useContainer(container: ContainerInstance): void;
    setStrict(strict: boolean): void;
    merge(options: StoreOptions<State>): void;
    loadModules<T extends {
        new (...args: any[]): {};
    }>(modules: T[]): void;
    loadModule<T extends {
        new (...args: any[]): {};
    }>(moduleClass: T): void;
    addModule(namespace: string, moduleOptions: Module<any, any>): void;
    create(): Store<State>;
}
export declare function getStoreBuilder(name?: string): StoreBuilder<{}>;
export {};
