import { Token } from 'typedi';
import { ModuleBuilder } from './module-builder';
import { StoreBuilder } from './store-builder';
export declare enum DecoratorType {
    STATE = 1,
    ACTION = 2,
    MUTATION = 3,
    GETTER = 4
}
export declare type DecoratorMap = Map<string, DecoratorType>;
export declare type InjectType = ((type?: any) => Function) | string | Token<any>;
export interface Injection {
    typeOrName: () => any;
    propertyName: string;
    index?: number;
}
export interface ModuleInternals {
    __moduleBuilder__: ModuleBuilder;
}
export interface StoreInternals {
    __storeBuilder__: StoreBuilder<any>;
}
export interface ModuleOptions {
    namespace: string;
}
