"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var KEY = '__decorators__';
function setDecorator(target, propertyName, decoratorType) {
    var decorators = getDecorators(target);
    if (decorators) {
        decorators.set(propertyName, decoratorType);
    }
}
exports.setDecorator = setDecorator;
function deleteDecorator(target, propertyName) {
    var decorators = getDecorators(target);
    if (decorators) {
        decorators.delete(propertyName);
    }
}
exports.deleteDecorator = deleteDecorator;
function getDecorators(target) {
    var ctor = typeof target === 'function' ? target : target.constructor;
    var proto = ctor.prototype;
    var decorators = proto[KEY];
    if (!decorators) {
        proto[KEY] = new Map();
        return proto[KEY];
    }
    return decorators;
}
exports.getDecorators = getDecorators;
//# sourceMappingURL=decorator-util.js.map