import { ContainerInstance } from 'typedi';
/**
 * Thrown when DI cannot inject value into property decorated by @Inject decorator.
 */
export declare class CannotInjectError extends Error {
    name: string;
    constructor(target: Object, propertyName: string);
}
export declare function registerInjection(target: any, propertyName: string, typeOrName?: any, index?: number): void;
/**
 * Inject all properties marked with @Inject() for the given class instance
 * @param instance Class instance
 */
export declare function injectAll(instance: any, container?: ContainerInstance): void;
